Home My Page Projects Code Snippets Project Openings SML/NJ
Summary Activity Forums Tracker Lists Tasks Docs Surveys News SCM Files

SCM Repository

[smlnj] Diff of /config/trunk/install.sh
ViewVC logotype

Diff of /config/trunk/install.sh

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

sml/branches/SMLNJ/config/install.sh revision 249, Sat Apr 17 18:57:03 1999 UTC sml/trunk/config/install.sh revision 1319, Wed Apr 9 19:04:27 2003 UTC
# Line 2  Line 2 
2  #  #
3  # Copyright (c) 1994 AT&T Bell Laboratories.  # Copyright (c) 1994 AT&T Bell Laboratories.
4  #  #
5  # installation script for SML/NJ and related tools; this is a temporary  # Installation script for SML/NJ and related tools; this is a temporary
6  # placeholder until the configuration tool is finished.  # placeholder until the configuration tool is finished.
7  #  #
8    # Significant changes to accommodate (and take advantage of) the new CM
9    # by M.Blume (2/2000).
10    #
11    
12    if [ x${INSTALL_QUIETLY} = xtrue ] ; then
13        export CM_VERBOSE=false
14    fi
15    
16    vsay() {
17        if [ x${INSTALL_DEBUG} = xtrue ] ; then
18            echo "$@"
19        elif [ x${INSTALL_QUIETLY} = xtrue ] ; then
20            :
21        else
22            echo "$@"
23        fi
24    }
25    
26    dsay() {
27        if [ x${INSTALL_DEBUG} = xtrue ] ; then
28            echo "$@"
29        fi
30    }
31    
32    complain() {
33        echo "$@"
34        exit 1
35    }
36    
37    # The following variable holds the name of all possible targets.
38    # The names must occur in the order in which targets are to be built.
39    ALLTARGETS=\
40    "src-smlnj \
41     ml-yacc \
42     ml-lex \
43     ml-burg \
44     ml-nlffigen \
45     smlnj-lib \
46     mlrisc \
47     cml \
48     cml-lib \
49     eXene \
50     ckit \
51     ml-nlffi-lib \
52     pgraph-util \
53     mlrisc-tools \
54     nowhere \
55     doc"
56    
57    this=$0
58    
59    # By default, move libraries to lib directory:
60    MOVE_LIBRARIES=true
61    
62    # function to be used in config/targets:
63    dont_move_libraries() { MOVE_LIBRARIES=false ; }
64    
65    # Initialize target list.
66    TARGETS=""
67    
68  #set -x  # function to be used in config/targets:
69    request() { TARGETS="$TARGETS $1" ; }
70    
71  #  #
72  # get the target list  # get the target list
73  #  #
74  if [ ! -r config/targets ]; then  if [ -r config/targets.customized ] ; then
75    echo "!!! no target list"      . config/targets.customized
76    exit 1;  elif [ ! -r config/targets ]; then
77  fi      complain "$this: !!! File config/targets is missing."
78    else
79  . config/targets  . config/targets
80    fi
81    
82  #  #
83  # some OSs have make in strange places  # resolve dependencies
84  #  #
85  MAKE=make  isnotin() {
86        tested_x=$1
87        shift
88        for set_y in "$@" ; do
89            if [ ${tested_x} = ${set_y} ] ; then
90                return 1
91            fi
92        done
93        return 0
94    }
95    
96    require() {
97        require_who=$1
98        shift
99        if isnotin ${require_who} ${TARGETS} ; then
100            :
101        else
102            for required_x in "$@" ; do
103                if isnotin ${required_x} ${TARGETS} ; then
104                    echo "Including ${required_x} (needed by ${require_who})."
105                    request ${required_x}
106                    CHANGED=true
107                fi
108            done
109        fi
110    }
111    
112    onepass() {
113        while read depline ; do
114            require $depline
115        done
116    }
117    
118    if [ -r config/dependencies ] ; then
119        CHANGED=true
120        while [ $CHANGED = true ]; do
121            CHANGED=false
122            onepass <config/dependencies
123        done
124    fi
125    
126  #  #
127  # command for building SML libraries; this should be either  # Rebuild target list using the order defined by ALLTARGETS.
 # "CM.recompile()" or "CM.stabilize true".  The latter builds  
 # stable libraries, which may be somewhat faster to use.  
128  #  #
129  #CM_MAKE_LIB="CM.recompile();"  NEWTARGETS=""
130  CM_MAKE_LIB="CM.stabilize true;"  for t in ${ALLTARGETS} ; do
131        if isnotin $t ${TARGETS} ; then
132            :
133        else
134            NEWTARGETS="$NEWTARGETS $t"
135        fi
136    done
137    TARGETS=$NEWTARGETS
138    
139  #  #
140  # check for ksh  # create the preloads.standard file
141    #
142    if [ ! -r config/preloads ]; then
143        complain "$this: !!! File config/preloads is missing."
144    fi
145    cp config/preloads preloads.standard
146    
147  #  #
148  # ksh causes some people problems so we will always use /bin/sh  # Some OSs have make in strange places, but most of the time it is
149    # simply on the PATH:
150  #  #
151  #echo "checking for ksh"  MAKE=make
152  #if [ -x /bin/ksh ]; then  
 #  SHELL=/bin/ksh  
 #elif [ -x /usr/local/bin/ksh ]; then  
 #  SHELL=/usr/local/bin/ksh  
 #else  
153    SHELL=/bin/sh    SHELL=/bin/sh
154  #fi  vsay $this: Using shell $SHELL.
 echo "  using $SHELL"  
155    
156  #  #
157  # set the SML root directory  # set the SML root directory
158  #  #
159  REAL_PWD=`pwd`  REAL_PWD=`pwd`
160  ROOT=${PWD:-$REAL_PWD}  ROOT=${PWD:-$REAL_PWD}
161  echo "SML root is $ROOT"  vsay $this: SML root is $ROOT.
162    vsay $this: Installation directory is ${INSTALLDIR:=$ROOT}.
163    
164  #  #
165  # set the various directory pathname variables  # set the various directory and file pathname variables
166  #  #
167  BINDIR=$ROOT/bin  BINDIR=$INSTALLDIR/bin          # main dir for binary stuff
168  CONFIGDIR=$ROOT/config  CONFIGDIR=$ROOT/config
169  HEAPDIR=$BINDIR/.heap  HEAPDIR=$BINDIR/.heap           # where heap images live
170  RUNDIR=$BINDIR/.run  RUNDIR=$BINDIR/.run             # where executables (i.e., the RTS) live
171  SRCDIR=$ROOT/src  SRCDIR=$ROOT/src                # where the source tree is rooted
172  LIBDIR=$ROOT/lib  LIBDIR=$INSTALLDIR/lib          # where libraries live
173    LIBLIST=$ROOT/liblist           # list of commands to stabilize libraries
174    LATESTANDALONES=$ROOT/latestandalones # standalone programs to be built late
175    LIBMOVESCRIPT=$ROOT/libmove     # a temporary script
176    LOCALPATHCONFIG=$INSTALLDIR/pathconfig # a temporary pathconfig file
177    
178  #  #
179  # the paths to ml-yacc and ml-lex; needed to configure CM  # The path to the dir where ml-yacc, ml-burg, ml-lex, ml-build, and
180    # ml-makedepend live.  This path will be interpreted relative to $LIBDIR.
181  #  #
182  YACCPATH=$BINDIR/ml-yacc  TOOLDIR=../bin
183  LEXPATH=$BINDIR/ml-lex  
184  BURGPATH=$BINDIR/ml-burg  #
185    # A temporary file for post-editing the pathconfig file...
186    #
187    PCEDITTMP=$INSTALLDIR/pcedittmp.$$
188    
189    #
190    # files to be deleted after we are done...
191    #
192    tmpfiles=""
193    tmpfiles="$tmpfiles $ROOT/preloads.standard"
194    tmpfiles="$tmpfiles $LIBLIST"
195    tmpfiles="$tmpfiles $LATESTANDALONES"
196    tmpfiles="$tmpfiles $LOCALPATHCONFIG"
197    tmpfiles="$tmpfiles $LIBMOVESCRIPT"
198    tmpfiles="$tmpfiles $PCEDITTMP"
199    #
200    # make sure we always clean up after ourselves...
201    #
202    trap 'rm -f $tmpfiles' 0 1 2 3 15
203    
204    
205  #  #
206  # set the CM configuration variables (these are environment variables  # set the CM configuration variables (these are environment variables
207  # that will be queried by the bootstrap code)  # that will be queried by the bootstrap code)
208  #  -M.Blume (5/1998)  # Especially important is CM_PATHCONFIG.
209  #  #
210  CM_YACC_DEFAULT=$YACCPATH  CM_PATHCONFIG=$LIBDIR/pathconfig
211  CM_LEX_DEFAULT=$LEXPATH  export CM_PATHCONFIG
 CM_BURG_DEFAULT=$BURGPATH  
 CM_PATH_DEFAULT=.:$LIBDIR  
 export CM_YACC_DEFAULT CM_LEX_DEFAULT CM_BURG_DEFAULT CM_PATH_DEFAULT  
212    
213  #  #
214  # the release version that we are installing  # the release version that we are installing
215  #  #
216  VERSION=`cat $CONFIGDIR/version`  VERSION=`cat $CONFIGDIR/version`
217  echo "installing version $VERSION"  vsay $this: Installing version $VERSION.
218    
219  #  #
220  # create the various sub directories  # the URL for the (usually remote) source archive
221  #  #
222  for dir in $BINDIR $HEAPDIR $RUNDIR $LIBDIR $SRCDIR  SRCARCHIVEURL=`cat $CONFIGDIR/srcarchiveurl`
223  do  vsay $this: URL of source archive is $SRCARCHIVEURL.
224    if [ -d $dir ]; then  
225      echo "$dir already exists"  #
226    # Function to make a directory including its ancestors.
227    #
228    makedir() {
229        if [ x$1 = x ] ; then
230            :
231        elif [ -d $1 ] ; then
232            :
233    else    else
234      echo "creating $dir"          makedir `dirname $1`
235      mkdir $dir          if [ x${INSTALL_VERBOSE} = xtrue ] ; then
236      if [ $? != "0" ]; then              vsay "$this: Making directory $1"
       echo "unable to create $dir"  
       exit 1  
237      fi      fi
238            if mkdir $1 ; then
239                :
240            else
241                complain "$this: !!! Unable to make directory $1!"
242            fi
243        fi
244    }
245    
246    #
247    # Function for asking user to fetch source archive.
248    #   $1 - descriptive name
249    #   $2 - base name without extension, without version, and without dir
250    #   $3 - remote directory
251    #
252    askurl() {
253        echo "$this: Please, fetch $1 archive"
254        echo ' ('$2.'*' or $VERSION-$2.'*)'
255        echo " from $3"
256        echo " and then re-run this script!"
257        exit 1
258    }
259    
260    #
261    # Function for fetching source archives automatically using wget or lynx.
262    #   $1 - command to actually get the stuff
263    #   $2 - descriptive name
264    #   $3 - base name without extension and without dir
265    #   $4 - remote directory
266    #
267    fetchurl() {
268        getter=$1 ; shift
269        vsay $this: Fetching $1 from $3. Please stand by...
270        fetched=no
271        for base in $2 $VERSION-$2 ; do
272            for ext in tgz tar.gz tar.Z tz tar tar.bz2 ; do
273                try=$base.$ext
274                vsay $this: Trying $try ...
275                if $getter $3/$try $ROOT/$try ; then
276                    fetched=yes
277                    vsay $this: Fetching $try was a success.
278                    break 2         # get out of both for-loops
279                else
280                    rm -f $ROOT/$try
281    fi    fi
282  done  done
283        done
284        if [ $fetched = no ] ; then
285            echo $this: Fetching $try was no success.
286            echo '  ' You should try to do it manually now.
287            askurl "$1" "$2" "$3"
288        fi
289    }
290    
291    # wrapper for wget
292    usewget() {
293        wget -nv -O $2 $1
294    }
295    
296    # wrapper for lynx
297    uselynx() {
298        lynx -source $1 >$2
299    }
300    
301    # wrapper for curl
302    usecurl() {
303        curl -s $1 >$2
304    }
305    
306    testurlgetter() {
307        (exec >/dev/null 2>&1 ; exec $*)
308    }
309    
310    #
311    # Function to check whether wget or lynx is available.
312    # Set URLGETTER accordingly.  URLGETTER can be set externally
313    # to either 'wget' or 'curl' or 'lynx' -- in which case the
314    # corresponding command will be used (properly wrapped).  Any
315    # other external setting will be passed directly to fetchurl (without
316    # wrapping -- meaning it must take precisely two argumets: source and
317    # destination, in that order).
318    #
319    urlgetter() {
320        case ${URLGETTER:-unknown} in
321            fetchurl*)
322                ;;
323            unknown)
324                # automatically figure out which wrapper to use
325                if testurlgetter wget --help ; then
326                    URLGETTER="fetchurl usewget"
327                elif testurlgetter curl -s -O file:///dev/null -o /dev/null ; then
328                    URLGETTER="fetchurl usecurl"
329                elif testurlgetter lynx -help ; then
330                    URLGETTER="fetchurl uselynx"
331                else
332                    URLGETTER="askurl"
333                fi
334                ;;
335            wget|curl|lynx)
336                # special getters we know how to wrap
337                URLGETTER="fetchurl use${URLGETTER}"
338                ;;
339            *)
340                # other -- must be able to work without wrapper
341                URLGETTER="fetchurl ${URLGETTER}"
342                ;;
343        esac
344    }
345    
346    # wrapper for tar
347    un_tar() {
348        vsay "$this: Un-TAR-ing $1 archive."
349        tar -xf $2
350    }
351    
352    # wrapper for zcat followed by tar
353    un_tar_Z() {
354        vsay "$this: Un-COMPRESS-ing and un-TAR-ing $1 archive."
355        zcat $2 | tar -xf -
356    }
357    
358    # wrapper for gunzip followed by tar
359    un_tar_gz() {
360        vsay "$this: Un-GZIP-ing and un-TAR-ing $1 archive."
361        gunzip -c $2 | tar -xf -
362    }
363    
364    # wrapper for bunzip2 followed by tar
365    un_tar_bz2() {
366        vsay "$this: Un-BZIP2-ing and un-TAR-ing $1 archive."
367        bunzip2 -c $2 | tar -xf -
368    }
369    
370    # unarchive archive without and with version number attached
371    unarchive() {
372        # $1: descriptive string, $2: archive, $3: unpacker
373        if [ -r $ROOT/$2 ] ; then
374            $3 "$1" $ROOT/$2
375        elif [ -r $ROOT/$VERSION-$2 ]; then
376            $3 "$1" $ROOT/$VERSION-$2
377        else
378            return 1
379        fi
380    }
381    
382    #
383    # Function to unpack a source archive.
384    #
385    # $1: descriptive name of the sources to be unpacked
386    # $2: the directory into which to unpack the sources
387    # $3: the sub-directory of $2 that is going to be created by unpacking
388    # $4: the basename of the source archive (the script will check several
389    #     different suffixes to determine what kind of de-compression is to
390    #     be used)
391    #
392    # fetch_n_unpack is the helper function that does the real work.  If
393    # no archive is found locally, it invokes $URLGETTER and tries again.
394    # The variable $tryfetch is used to make sure this happens only once.
395    fetch_n_unpack() {
396        cd $2
397        if unarchive "$1" $4.tgz un_tar_gz ||
398           unarchive "$1" $4.tar.gz un_tar_gz ||
399           unarchive "$1" $4.tar.Z un_tar_Z ||
400           unarchive "$1" $4.tar un_tar ||
401           unarchive "$1" $4.tar.bz2 un_tar_bz2 ||
402           unarchive "$1" $4.tz un_tar_Z
403        then
404            : we are done
405        elif [ $tryfetch = yes ] ; then
406            urlgetter
407            $URLGETTER "$1" $4 $SRCARCHIVEURL
408            tryfetch=no
409            fetch_n_unpack "$1" "$2" "$3" "$4"
410        fi
411    }
412    
413    #
414    # The main "unpack" driver function that invokes the above helper.
415    #
416    unpack() {
417        tryfetch=yes
418        if [ -d $2/$3 ]; then
419            vsay "$this: The $1 tree already exists."
420        else
421            fetch_n_unpack "$1" "$2" "$3" "$4"
422        fi
423        if [ ! -d $2/$3 ]; then
424            complain "$this: !!! Unable to unpack $1 archive."
425        fi
426    }
427    
428    # A function to move all stable library files to a parallel directory
429    # hierarchy.
430    # The first argument must be a simple path (no / inside), and
431    # the second argument must be an absolute path.
432    move() {
433        if [ -d $1 ] ; then
434            if [ ! -d $2 ] ; then
435                if [ -f $2 ] ; then
436                    complain $this: $2 exists as a non-directory.
437                fi
438                mkdir $2
439            fi
440            cd $1
441            for i in * ; do
442                move $i $2/$i
443            done
444            cd ..
445        elif [ -f $1 ] ; then
446            rm -f $2
447            mv $1 $2
448        fi
449    }
450    
451    # move stable library file from $1 to $2
452    movelib()
453    {
454        SOURCE=$1
455        TARGET=$2
456        TARGETDIR=`dirname ${TARGET}`
457        if [ ! -d ${TARGETDIR} ] ; then
458            makedir ${TARGETDIR}
459        fi
460        mv ${SOURCE} ${TARGET}
461    }
462    
463    # A shell function that registers a library for being built.
464    # This function takes 3 arguments:
465    #   $1 = controlling anchor
466    #   $2 = name relative to controlling anchor
467    #   $3 = dir (relative to ${SRCDIR}) corresponding to $1
468  #  #
469  # install the script that tests the architecture, and make sure that it works  # This works by adding ML code to file $LIBLIST.  The code in this file
470    # will be executed near the end of this script.  If $MOVE_LIBRARIES is
471    # set to true, then reglib will also register a "movelib" to be executed at
472    # the end by putting a "movelib" line into $LIBMOVESCRIPT.
473    reglib() {
474        ANCHOR=$1
475        RELNAME=$2
476        LIBNAME='$'${ANCHOR}/${RELNAME}
477        ADIR=${SRCDIR}/$3
478        if [ $# -gt 3 ] ; then
479            FINALANCHOR=$4
480        else
481            FINALANCHOR=$ANCHOR
482        fi
483        RELDIR=`dirname $RELNAME`
484        RELBASE=`basename $RELNAME`
485        if [ x$RELDIR = x. ] ; then
486            RELDIR=
487        else
488            RELDIR=/$RELDIR
489        fi
490        RELLOC=${RELDIR}/CM/${ARCH}-unix/${RELBASE}
491        SRCFINALLOC=${ADIR}${RELLOC}
492        if [ x$MOVE_LIBRARIES = xtrue ] ; then
493            FINALLOC=${LIBDIR}/${FINALANCHOR}${RELLOC}
494            FINALCONFIGPATH=${FINALANCHOR}
495        else
496            FINALLOC=${SRCFINALLOC}
497            FINALCONFIGPATH=${ADIR}
498        fi
499    
500        if [ -f ${FINALLOC} ] ; then
501            vsay "$this: Library ${LIBNAME} already exists in ${FINALLOC}"
502        else
503            vsay "$this: Scheduling library ${LIBNAME} to be built as ${FINALLOC}."
504            echo "  andalso CM.stabilize false \"${LIBNAME}\"" >>${LIBLIST}
505            echo ${ANCHOR} ${ADIR} >>${LOCALPATHCONFIG}
506            if [ x$MOVE_LIBRARIES = xtrue ] ; then
507                echo movelib ${SRCFINALLOC} ${FINALLOC} >>${LIBMOVESCRIPT}
508            fi
509        fi
510        echo ${FINALANCHOR} ${FINALCONFIGPATH} >>${CM_PATHCONFIG}
511    }
512    
513    #
514    # Function for adding anchor bindings to LOCALPATHCONFIG
515    #
516    # $1 - anchor name
517    # $2 - directory relative to ROOT corresponding to $1
518    localanchor() {
519        echo $1 ${ROOT}/$2 >>${LOCALPATHCONFIG}
520    }
521    
522  #  #
523  if [ -x $BINDIR/.arch-n-opsys ]; then  # Function to build a standalone program such as ml-yacc.  The function takes
524    echo "$BINDIR/.arch-n-opsys already exists"  # 2 or 3 or 4 arguments.  First the name of the program which at the same time
525    # is the directory name under $SRCDIR/$4 where the sources reside.  The second
526    # argument is a descriptive name for the program (passed on to "unpack").
527    # The optional third argument specifies the path relative to $SRCDIR/$4/$1
528    # of the directory where the program's heap image is to be found.
529    # The fourth argument, if missing, defaults to "."
530    #
531    
532    standalone() {
533        TARGET=$1.$HEAP_SUFFIX
534        if [ $# = 3 ] ; then
535            TARGETLOC=$3/$TARGET
536  else  else
537    cat $CONFIGDIR/_arch-n-opsys | sed -e "s,@SHELL@,$SHELL,g" > $BINDIR/.arch-n-opsys          TARGETLOC=$TARGET
538    chmod 555 $BINDIR/.arch-n-opsys      fi
539    if [ ! -x $BINDIR/.arch-n-opsys ]; then      if [ $# = 4 ] ; then
540      echo "!!! installation of $BINDIR/.arch-n-opsys failed for some reason"           MYSRCDIR=$SRCDIR/$4
541      exit 1      else
542             MYSRCDIR=$SRCDIR
543    fi    fi
544        if [ -r $HEAPDIR/$TARGET ] ; then
545            vsay $this: Target $TARGET already exists.
546        else
547            echo $this: Building $TARGET.
548            unpack $2 $MYSRCDIR $1 $1
549            cd $MYSRCDIR/$1
550            # build it, but make sure we don't pick up some (unrelated)
551            # local path configuration...
552            CM_LOCAL_PATHCONFIG=/dev/null ./build
553            if [ -r $TARGETLOC ] ; then
554                mv $TARGETLOC $HEAPDIR/$TARGET
555                if [ ! -f $BINDIR/$1 ] ; then
556                    cd $BINDIR
557                    ln -s .run-sml $1
558  fi  fi
559            else
560                echo "$this: !!! Build of $TARGET failed."
561            fi
562        fi
563    }
564    
565    ######################################################################
566    
567    #
568    # create the various sub directories
569    #
570    for dir in $BINDIR $HEAPDIR $RUNDIR $LIBDIR $SRCDIR ; do
571        makedir $dir
572    done
573    
574    #
575    # Function to install a "driver" script...
576    #   This takes care of patching the source of the script with the SHELL,
577    #   BINDIR, and VERSION variables to use.
578    #
579    installdriver() {
580        dsrc=$1
581        ddst=$2
582    # We install the driver unconditionally. (It would be better to test
583    # for an outdated driver script, but not all "test" commands understand
584    # the -nt comparison operator....)
585    #   if [ -x $BINDIR/$ddst ]; then
586    #       echo $this: Script $BINDIR/$ddst already exists.
587    #   else
588            rm -f $BINDIR/$ddst
589            cat $CONFIGDIR/$dsrc | \
590            sed -e "s,@SHELL@,$SHELL,g" \
591                -e "s,@BINDIR@,$BINDIR," \
592                -e "s,@VERSION@,$VERSION," \
593                > $BINDIR/$ddst
594            chmod 555 $BINDIR/$ddst
595            if [ ! -x $BINDIR/$ddst ]; then
596                complain "$this: !!! Installation of $BINDIR/${ddst} failed."
597            fi
598    #   fi
599    }
600    
601    #
602    # install the script that tests architecture and os...
603    #
604    installdriver _arch-n-opsys .arch-n-opsys
605    
606    #
607    # run it to figure out what architecture and os we are using, define
608    # corresponding variables...
609    #
610  ARCH_N_OPSYS=`$BINDIR/.arch-n-opsys`  ARCH_N_OPSYS=`$BINDIR/.arch-n-opsys`
611  if [ "$?" != "0" ]; then  if [ "$?" != "0" ]; then
612    echo "!!! $BINDIR/.arch-n-opsys fails on this machine"      echo "$this: !!! Script $BINDIR/.arch-n-opsys fails on this machine."
613    echo "!!! you must patch this by hand and repeat the installation"      echo "$this: !!! You must patch this by hand and repeat the installation."
614    exit 2    exit 2
615  else  else
616    echo "$BINDIR/.arch-n-opsys reports $ARCH_N_OPSYS"      vsay $this: Script $BINDIR/.arch-n-opsys reports $ARCH_N_OPSYS.
617  fi  fi
618  eval $ARCH_N_OPSYS  eval $ARCH_N_OPSYS
619    
620  if [ -x $BINDIR/.run-sml ]; then  #
621    echo "$BINDIR/.run-sml already exists"  # now install all the other driver scripts...
622  else  #
623    cat $CONFIGDIR/_run-sml | \  installdriver _run-sml .run-sml
624      sed -e "s,@SHELL@,$SHELL,g" -e "s,@BINDIR@,$BINDIR," -e "s,@VERSION@,$VERSION," \  installdriver _link-sml .link-sml
625      > $BINDIR/.run-sml  installdriver _ml-build ml-build
626    chmod 555 $BINDIR/.run-sml  installdriver _ml-makedepend ml-makedepend
   if [ ! -x $BINDIR/.run-sml ]; then  
     echo "!!! installation of $BINDIR/.run-sml failed for some reason"  
     exit 1  
   fi  
 fi  
627    
628  #  #
629  # set some architecture dependent run-time system flags  # set some architecture dependent run-time system flags
630  #  #
631  case $ARCH in  case $ARCH in
632    mips*) ALLOC=1M ;;      mips*)
633            ALLOC=1M
634            ;;
635    x86)    x86)
636            # The following is the _wrong_ value for many popular x86 chips
637            # (i.e., Celerons).  However, the optimal value for those is 32k,
638            # and such a small value is not enough for the runtime system's boot
639            # code.  Therefore, we use 256k here and re-set it to the proper
640            # value in .run-sml.
641      ALLOC=256k      ALLOC=256k
642    ;;    ;;
643    alpha32)    alpha32)
# Line 155  Line 647 
647      ALLOC=512k      ALLOC=512k
648    ;;    ;;
649  esac  esac
650    
651  case $OPSYS in  case $OPSYS in
652    solaris)    solaris)
653      MAKE=/usr/ccs/bin/make      MAKE=/usr/ccs/bin/make
# Line 162  Line 655 
655    linux)    linux)
656      EXTRA_DEFS=`$CONFIGDIR/chk-global-names.sh`      EXTRA_DEFS=`$CONFIGDIR/chk-global-names.sh`
657      if [ "$?" != "0" ]; then      if [ "$?" != "0" ]; then
658        echo "problems checking for underscores in global names"              complain "$this: !!! Problems checking for underscores in asm names."
       exit 1  
659      fi      fi
660      EXTRA_DEFS="XDEFS=$EXTRA_DEFS"      EXTRA_DEFS="XDEFS=$EXTRA_DEFS"
661    ;;    ;;
# Line 172  Line 664 
664  #  #
665  # the name of the bin files directory  # the name of the bin files directory
666  #  #
667  BIN_FILES=bin.$ARCH-unix  BOOT_ARCHIVE=boot.$ARCH-unix
668    BOOT_FILES=sml.$BOOT_ARCHIVE
669    
670  #  #
671  # build the run-time system  # build the run-time system
672  #  #
673  $CONFIGDIR/unpack.sh "run-time" $SRCDIR runtime $ROOT/$VERSION-runtime.tar  unpack "run-time" $SRCDIR runtime runtime
674  if [ "$?" != "0" ]; then  if [ -x $RUNDIR/run.$ARCH-$OPSYS ]; then
675    exit $?      vsay $this: Run-time system already exists.
676  fi  else
 if [ ! -x $RUNDIR/run.$ARCH-$OPSYS ]; then  
677    cd $SRCDIR/runtime/objs    cd $SRCDIR/runtime/objs
678    echo "compiling the run-time system"      echo $this: Compiling the run-time system.
679    $MAKE -f mk.$ARCH-$OPSYS $EXTRA_DEFS    $MAKE -f mk.$ARCH-$OPSYS $EXTRA_DEFS
680    if [ -x run.$ARCH-$OPSYS ]; then    if [ -x run.$ARCH-$OPSYS ]; then
681      mv run.$ARCH-$OPSYS $RUNDIR      mv run.$ARCH-$OPSYS $RUNDIR
682      $MAKE MAKE=$MAKE clean      $MAKE MAKE=$MAKE clean
683    else    else
684      echo "!!! run-time system build failed for some reason"          complain "$this: !!! Run-time system build failed for some reason."
     exit 1  
685    fi    fi
686  fi  fi
687  cd $SRCDIR  cd $SRCDIR
# Line 199  Line 690 
690  # boot the base SML system  # boot the base SML system
691  #  #
692  if [ -r $HEAPDIR/sml.$HEAP_SUFFIX ]; then  if [ -r $HEAPDIR/sml.$HEAP_SUFFIX ]; then
693    echo "$HEAPDIR/sml.$HEAP_SUFFIX already exists"      vsay $this: Heap image $HEAPDIR/sml.$HEAP_SUFFIX already exists.
694  else  else
695    $CONFIGDIR/unpack.sh bin $ROOT $BIN_FILES $ROOT/$VERSION-$BIN_FILES.tar      unpack bin $ROOT $BOOT_FILES $BOOT_ARCHIVE
696        cd $ROOT/$BOOT_FILES
697        if $BINDIR/.link-sml @SMLheap=$ROOT/sml @SMLboot=BOOTLIST @SMLalloc=$ALLOC
698        then
699    cd $ROOT    cd $ROOT
   $RUNDIR/run.$ARCH-$OPSYS @SMLboot=$ROOT/$BIN_FILES @SMLalloc=$ALLOC <<XXXX  
     $SET_FLAGS  
     val use = Compiler.Interact.useFile  
     val _ = (SMLofNJ.exportML "sml";  
              print Compiler.banner;  
              print "\n");  
 XXXX  
700    if [ -r sml.$HEAP_SUFFIX ]; then    if [ -r sml.$HEAP_SUFFIX ]; then
701      mv sml.$HEAP_SUFFIX $HEAPDIR      mv sml.$HEAP_SUFFIX $HEAPDIR
702      cd $BINDIR      cd $BINDIR
703      ln -s .run-sml sml      ln -s .run-sml sml
704                #
705                # Now move all stable libraries to #LIBDIR and generate
706                # the pathconfig file.
707                #
708                cd $ROOT/$BOOT_FILES
709                for anchor in * ; do
710                    if [ -d $anchor ] ; then
711                        echo $anchor $anchor >>$CM_PATHCONFIG
712                        move $anchor $LIBDIR/$anchor
713                    fi
714                done
715                cd $ROOT
716                # $BOOT_FILES is now only an empty skeleton, let's get rid of it.
717                rm -rf $BOOT_FILES
718    
719    else    else
720      echo "!!! unable to build SML heap image (sml.$HEAP_SUFFIX)"              complain "$this !!! No heap image generated (sml.$HEAP_SUFFIX)."
721      exit 1          fi
722        else
723            complain "$this !!! Boot code failed, no heap image (sml.$HEAP_SUFFIX)."
724    fi    fi
725  fi  fi
726    
727    #
728    # Initialize $LIBLIST
729    #
730    cd $ROOT
731    rm -f $LOCALPATHCONFIG $LIBLIST
732    echo 'ignore (OS.Process.exit (if true' >$LIBLIST
733    
734  #  #
735  # now build the individual targets  # now build (or prepare to build) the individual targets
736  #  #
737  cd $SRCDIR  cd $SRCDIR
738  echo "install targets"  vsay $this: Installing other targets.
739  for i in $TARGETS  for i in $TARGETS ; do
 do  
   if [ $i = "doc" ]; then  
     TARGET=$i  
   else  
     TARGET=$i.$HEAP_SUFFIX  
   fi  
   if [ -r $HEAPDIR/$TARGET ]; then  
     echo "$TARGET already exists"  
   else  
     echo "  building $TARGET"  
740      case $i in      case $i in
741        src-smlnj)        src-smlnj)
742          for src in compiler comp-lib cm MLRISC; do          for src in compiler cm MLRISC smlnj-lib ml-yacc system
743            $CONFIGDIR/unpack.sh $src $ROOT/src $src $ROOT/$VERSION-$src.tar          do
744                unpack $src $ROOT/src $src $src
745          done          done
746        ;;        ;;
       sml-full)  
         if [ ! -d $ROOT/$BIN_FILES ]; then  
           echo "!!! bin files are missing; build of $TARGET failed"  
           exit 1  
         else  
           cd $ROOT  
           $RUNDIR/run.$ARCH-$OPSYS @SMLfull @SMLboot=$ROOT/$BIN_FILES @SMLalloc=$ALLOC <<XXXX  
             $SET_FLAGS  
             val use = Compiler.Interact.useFile  
             val _ = (SMLofNJ.exportML "sml-full";  
                      print Compiler.banner;  
                      print " [full]\n");  
 XXXX  
           if [ -r sml-full.$HEAP_SUFFIX ]; then  
             mv sml-full.$HEAP_SUFFIX $HEAPDIR  
             cd $BINDIR  
             ln -s .run-sml sml-full  
           else  
             echo "!!! unable to build SML-FULL heap image"  
             exit 1  
           fi  
         fi  
       ;;  
747        ml-yacc)        ml-yacc)
748          $CONFIGDIR/unpack.sh ML-Yacc $SRCDIR ml-yacc $ROOT/$VERSION-ml-yacc.tar          standalone ml-yacc ML-Yacc src
749          if [ "$?" != "0" ]; then          echo ml-yacc $TOOLDIR >>$CM_PATHCONFIG
           exit $?  
         fi  
         cd $SRCDIR/ml-yacc  
         ./build  
         if [ -r src/$TARGET ]; then  
           mv src/$TARGET $HEAPDIR  
           if [ ! -f $BINDIR/$i ]; then  
             cd $BINDIR  
             ln -s .run-sml $i  
           fi  
         else  
           echo "!!! build of $TARGET failed"  
           exit 1  
         fi  
750        ;;        ;;
751        ml-lex)        ml-lex)
752          $CONFIGDIR/unpack.sh ML-Lex $SRCDIR ml-lex $ROOT/$VERSION-ml-lex.tar          standalone ml-lex ML-Lex
753          if [ "$?" != "0" ]; then          echo ml-lex $TOOLDIR >>$CM_PATHCONFIG
           exit $?  
         fi  
         cd $SRCDIR/ml-lex  
         ./build  
         if [ -r $TARGET ]; then  
           mv $TARGET $HEAPDIR  
           if [ ! -f $BINDIR/$i ]; then  
             cd $BINDIR  
             ln -s .run-sml $i  
           fi  
         else  
           echo "!!! build of $TARGET failed"  
           exit 1  
         fi  
754        ;;        ;;
755        ml-burg)        ml-burg)
756          $CONFIGDIR/unpack.sh ML-Burg $SRCDIR ml-burg $ROOT/$VERSION-ml-burg.tar          standalone ml-burg ML-Burg
757          if [ "$?" != "0" ]; then          echo ml-burg $TOOLDIR >>$CM_PATHCONFIG
758            exit $?          ;;
759          fi        ml-nlffigen)
760          cd $SRCDIR/ml-burg          echo standalone ml-nlffigen ML-NLFFI-Gen >>$LATESTANDALONES
761          ./build          echo ml-nlffigen $TOOLDIR >>$CM_PATHCONFIG
         if [ -r $TARGET ]; then  
           mv $TARGET $HEAPDIR  
           if [ ! -f $BINDIR/$i ]; then  
             cd $BINDIR  
             ln -s .run-sml $i  
           fi  
         else  
           echo "!!! build of $TARGET failed"  
           exit 1  
         fi  
762        ;;        ;;
763        smlnj-lib)        smlnj-lib)
764          $CONFIGDIR/unpack.sh "SML/NJ Library" $SRCDIR smlnj-lib $ROOT/$VERSION-smlnj-lib.tar          unpack "SML/NJ Library" $SRCDIR smlnj-lib smlnj-lib
765          if [ "$?" != "0" ]; then  
766            exit $?          # Don't make the Util library -- it came pre-made and has been
767          fi          # installed when making the base system.  In other words, don't do...
768        # make the Util library              #reglib smlnj-lib.cm smlnj-lib.cm smlnj-lib/Util
769          cd $SRCDIR/smlnj-lib/Util          # ... and don't make the HTML library ...
770          echo "$CM_MAKE_LIB" | $BINDIR/sml              #reglib html-lib.cm html-lib.cm smlnj-lib/HTML
771          if [ ! -f $LIBDIR/smlnj-lib.cm ]; then          # ... and don't make the PP library ...
772            cd $LIBDIR              #reglib pp-lib.cm pp-lib.cm smlnj-lib/PP
773            echo "Alias $SRCDIR/smlnj-lib/Util/sources.cm" > smlnj-lib.cm          # ... and don't make the controls library ...
774          fi              #reglib controls-lib.cm controls-lib.cm smlnj-lib/Controls
775        # make the Unix library        # make the Unix library
776          cd $SRCDIR/smlnj-lib/Unix              reglib unix-lib.cm unix-lib.cm smlnj-lib/Unix
777          echo "$CM_MAKE_LIB" | $BINDIR/sml          # make the INet library
778          if [ ! -f $LIBDIR/unix-lib.cm ]; then              reglib inet-lib.cm inet-lib.cm smlnj-lib/INet
           cd $LIBDIR  
           echo "Alias $SRCDIR/smlnj-lib/Unix/sources.cm" > unix-lib.cm  
         fi  
       # make the HTML library  
         cd $SRCDIR/smlnj-lib/HTML  
         echo "$CM_MAKE_LIB" | $BINDIR/sml  
         if [ ! -f $LIBDIR/html-lib.cm ]; then  
           cd $LIBDIR  
           echo "Alias $SRCDIR/smlnj-lib/HTML/sources.cm" > html-lib.cm  
         fi  
       # make the Reactive library  
         cd $SRCDIR/smlnj-lib/Reactive  
         echo "$CM_MAKE_LIB" | $BINDIR/sml  
         if [ ! -f $LIBDIR/reactive-lib.cm ]; then  
           cd $LIBDIR  
           echo "Alias $SRCDIR/smlnj-lib/Reactive/sources.cm" > reactive-lib.cm  
         fi  
       # make the PP library  
         cd $SRCDIR/smlnj-lib/PP  
         echo "$CM_MAKE_LIB" | $BINDIR/sml  
         if [ ! -f $LIBDIR/pp-lib.cm ]; then  
           cd $LIBDIR  
           echo "Alias $SRCDIR/smlnj-lib/PP/sources.cm" > pp-lib.cm  
         fi  
779        # make the RegExp library        # make the RegExp library
780          cd $SRCDIR/smlnj-lib/RegExp              reglib regexp-lib.cm regexp-lib.cm smlnj-lib/RegExp
781          echo "$CM_MAKE_LIB" | $BINDIR/sml          # make the Reactive library
782          if [ ! -f $LIBDIR/regexp-lib.cm ]; then              reglib reactive-lib.cm reactive-lib.cm smlnj-lib/Reactive
783            cd $LIBDIR          # make the HashCons library
784            echo "Alias $SRCDIR/smlnj-lib/RegExp/sources.cm" > regexp-lib.cm              reglib hash-cons-lib.cm hash-cons-lib.cm smlnj-lib/HashCons
         fi  
       ;;  
       ml-yacc-lib)  
         $CONFIGDIR/unpack.sh ML-Yacc $SRCDIR ml-yacc $ROOT/$VERSION-ml-yacc.tar  
         if [ "$?" != "0" ]; then  
           exit $?  
         fi  
         cd $SRCDIR/ml-yacc/lib  
         echo "$CM_MAKE_LIB" | $BINDIR/sml  
         if [ ! -f $LIBDIR/ml-yacc-lib.cm ]; then  
           cd $LIBDIR  
           echo "Alias $SRCDIR/ml-yacc/lib/sources.cm" > ml-yacc-lib.cm  
         fi  
785        ;;        ;;
786        cml)        cml)
787          $CONFIGDIR/unpack.sh CML $SRCDIR cml $ROOT/$VERSION-cml.tar          unpack CML $SRCDIR cml cml
788          if [ "$?" != "0" ]; then          reglib cml core-cml.cm cml/src
789            exit $?          reglib cml cml-internal.cm cml/src
790          fi          reglib cml cml.cm cml/src
791          cd $SRCDIR/cml/src          reglib cml basis.cm cml/src
         echo "$CM_MAKE_LIB" | $BINDIR/sml  
         if [ ! -f $LIBDIR/cml.cm ]; then  
           cd $LIBDIR  
           echo "Alias $SRCDIR/cml/src/sources.cm" > cml.cm  
         fi  
792        ;;        ;;
793        cml-lib)        cml-lib)
794          $CONFIGDIR/unpack.sh CML $SRCDIR cml $ROOT/$VERSION-cml.tar          unpack CML $SRCDIR cml cml
795          if [ "$?" != "0" ]; then          reglib cml-lib trace-cml.cm cml/cml-lib/cm-descr
796            exit $?          reglib cml-lib smlnj-lib.cm cml/cml-lib/cm-descr
         fi  
         cd $SRCDIR/cml/cml-lib  
         echo "$CM_MAKE_LIB" | $BINDIR/sml  
         if [ ! -f $LIBDIR/cml-lib.cm ]; then  
           cd $LIBDIR  
           echo "Alias $SRCDIR/cml/cml-lib/sources.cm" > cml-lib.cm  
         fi  
       ;;  
       cml-cm)  
         CMD="CM.autoloading(SOME true); CM.clearAutoList();"  
         CMD="$CMD CM.autoload'(\"$LIBDIR/cml.cm\");"  
         if [ "$AUTOLOAD_CML_LIB" = "TRUE" ]; then  
           CMD="$CMD CM.autoload'(\"$LIBDIR/cml-lib.cm\");"  
         fi  
         if [ "$AUTOLOAD_EXENE" = "TRUE" ]; then  
           CMD="$CMD CM.autoload'(\"$LIBDIR/eXene.cm\");"  
         fi  
         cd $ROOT  
         $BINDIR/sml <<XXXX  
           $CMD  
           val _ = (SMLofNJ.exportML "$i";  
                 print CML.banner;  
                 print "[CML autoload]\n");  
 XXXX  
         if [ -r $TARGET ]; then  
           mv $TARGET $HEAPDIR  
           if [ ! -f $BINDIR/$i ]; then  
             cd $BINDIR  
             ln -s .run-sml $i  
           fi  
         else  
           echo "!!! unable to build autoloading CML"  
           exit 1  
         fi  
797        ;;        ;;
798        eXene)        eXene)
799          $CONFIGDIR/unpack.sh EXene $SRCDIR eXene $ROOT/$VERSION-eXene.tar          unpack EXene $SRCDIR eXene eXene
800          if [ "$?" != "0" ]; then          reglib eXene.cm eXene.cm eXene
801            exit $?          ;;
802          fi        ckit)
803          cd $SRCDIR/eXene          unpack "C-Kit" $ROOT ckit ckit
804          echo "$CM_MAKE_LIB" | $BINDIR/sml          reglib ckit-lib.cm ckit-lib.cm ../ckit/src
805          if [ ! -f $LIBDIR/eXene.cm ]; then          ;;
806            cd $LIBDIR        ml-nlffi-lib)
807            echo "Alias $SRCDIR/eXene/sources.cm" > eXene.cm          unpack "NLFFI Library" $SRCDIR ml-nlffi-lib ml-nlffi-lib
808          fi          reglib c memory/memory.cm ml-nlffi-lib
809            reglib c internals/c-int.cm ml-nlffi-lib
810            reglib c c.cm ml-nlffi-lib
811            ;;
812          pgraph-util)
813            unpack "CM source code" $SRCDIR cm cm
814            reglib pgraph-util.cm pgraph-util.cm cm/pgraph
815            ;;
816          mlrisc)
817            unpack "MLRISC Library" $SRCDIR MLRISC MLRISC
818            localanchor Control.cm lib/SMLNJ-MLRISC
819            localanchor Lib.cm lib/SMLNJ-MLRISC
820            localanchor Visual.cm lib/SMLNJ-MLRISC
821            localanchor MLRISC.cm lib/SMLNJ-MLRISC
822            localanchor MLTREE.cm lib/SMLNJ-MLRISC
823            localanchor Graphs.cm lib/SMLNJ-MLRISC
824            localanchor IA32.cm lib/SMLNJ-MLRISC
825            localanchor Peephole.cm src/MLRISC/cm
826            reglib OTHER-MLRISC RA.cm MLRISC/cm SMLNJ-MLRISC
827            reglib OTHER-MLRISC Peephole.cm MLRISC/cm SMLNJ-MLRISC
828            reglib OTHER-MLRISC IA32-Peephole.cm MLRISC/cm SMLNJ-MLRISC
829            ;;
830          mlrisc-tools)
831            unpack "MLRISC Tools Library" $SRCDIR MLRISC MLRISC
832            reglib mlrisc-tools pp.cm MLRISC/Tools
833            reglib mlrisc-tools source-map.cm MLRISC/Tools
834            reglib mlrisc-tools sml-ast.cm MLRISC/Tools
835            reglib mlrisc-tools prec-parser.cm MLRISC/Tools
836            reglib mlrisc-tools parser.cm MLRISC/Tools
837            reglib mlrisc-tools match-compiler.cm MLRISC/Tools
838            ;;
839          nowhere)
840            unpack "MLRISC Tools Library" $SRCDIR MLRISC MLRISC
841            echo standalone nowhere NoWhere . MLRISC/Tools >>$LATESTANDALONES
842            echo nowhere $TOOLDIR >>$CM_PATHCONFIG
843        ;;        ;;
844        doc)        doc)
845          $CONFIGDIR/unpack.sh Doc $ROOT doc $ROOT/$VERSION-doc.tar          echo Package doc is currently unavailable.
846          if [ "$?" != "0" ]; then          # unpack Doc $ROOT doc doc
847            exit $?          # cd $ROOT/doc
848          fi          # build $ROOT
         cd $ROOT/doc  
         build $ROOT  
849        ;;        ;;
850        *)        *)
851          echo "!!! unknown target $i"          echo "$this: !!! Unknown target $i."
852        ;;        ;;
853      esac      esac
   fi  
854  done  done
855    
856  if [ "$ENABLE_AUTOLOADING" = "TRUE" ]; then  #
857    CMD="CM.autoloading(SOME true); CM.clearAutoList();"  # Now go and stabilize all registered libraries...
858    if [ "$AUTOLOAD_SMLNJ_LIB" = "TRUE" ]; then  # This is done with library sources in their original locations inside
859      CMD="$CMD CM.autoload'(\"$LIBDIR/smlnj-lib.cm\");"  # $SRCDIR, so we must consult $LOCALPATHCONFIG.
860    fi  #
861    if [ "$AUTOLOAD_SMLNJ_UNIX" = "TRUE" ]; then  
862      CMD="$CMD CM.autoload'(\"$LIBDIR/unix-lib.cm\");"  echo $this: Compiling library code.
863    fi  echo 'then OS.Process.success else OS.Process.failure));' >>$LIBLIST
864    if [ "$AUTOLOAD_SMLNJ_HTML" = "TRUE" ]; then  if CM_LOCAL_PATHCONFIG=$LOCALPATHCONFIG $BINDIR/sml <$LIBLIST ; then
865      CMD="$CMD CM.autoload'(\"$LIBDIR/html-lib.cm\");"      vsay $this: Libraries compiled successfully.
866    fi  else
867    if [ "$AUTOLOAD_SMLNJ_REACTIVE" = "TRUE" ]; then      complain "$this: !!! Something went wrong when compiling the libraries."
     CMD="$CMD CM.autoload'(\"$LIBDIR/reactive-lib.cm\");"  
   fi  
   if [ "AUTOLOAD_SMLNJ_PP" = "TRUE" ]; then  
     CMD="$CMD CM.autoload'(\"$LIBDIR/pp-lib.cm\");"  
868    fi    fi
869    if [ "AUTOLOAD_SMLNJ_REGEXP" = "TRUE" ]; then  
870      CMD="$CMD CM.autoload'(\"$LIBDIR/regexp-lib.cm\");"  #
871    # Move the libraries to their final locations...
872    #
873    
874    if [ -r $LIBMOVESCRIPT ] ; then
875        vsay $this: Moving libraries to $LIBDIR.
876        . $LIBMOVESCRIPT
877    fi    fi
878    cd $ROOT  
879    $BINDIR/sml <<XXXX  #
880      $CMD  # Build "late" standalone programs (i.e., those that must be built
881      val _ = (SMLofNJ.exportML "sml";  # after libraries are already in place):
882               print Compiler.banner;  #
883               print " [CM; autoload enabled]\n");  
884  XXXX  if [ -r $LATESTANDALONES ] ; then
885    if [ -r sml.$HEAP_SUFFIX ]; then      vsay $this: Building late standalone programs.
886      mv sml.$HEAP_SUFFIX $HEAPDIR      . $LATESTANDALONES
   else  
     echo "!!! unable to build SML with autoloading"  
     exit 1  
887    fi    fi
888    
889    #
890    # Finally, remove duplicate entries from pathconfig file...
891    #
892    if [ -f $CM_PATHCONFIG ] ; then
893        cp $CM_PATHCONFIG $PCEDITTMP
894        rm -f $CM_PATHCONFIG
895        awk <$PCEDITTMP 'NF == 2 { mapping[$1] = $2 }
896    NF != 2 { print $0 }
897    END { for (i in mapping) print i, mapping[i] }' \
898          | sort >$CM_PATHCONFIG
899  fi  fi
900    
901    exit 0

Legend:
Removed from v.249  
changed lines
  Added in v.1319

root@smlnj-gforge.cs.uchicago.edu
ViewVC Help
Powered by ViewVC 1.0.0